//-----------------------------------------------------------------------------
/*
Programmed by Olivier Sangala
http://olivier.sangala.free.fr
olivier_sangala@hotmail.com
*/
//-----------------------------------------------------------------------------

#define POS_LEFT (2)
#define POS_TOP (26)

#define CURSORFINGER_X (5)
#define CURSORFINGER_Y (0)

#define CURSORHAND_X (7)
#define CURSORHAND_Y (13)

#define CURSORTILE_X (8)
#define CURSORTILE_Y (12)

#define CURSOR_HEIGHT (22)

#define BOARDS_COUNT (128)
#define HAND_HOLE (-1)


//--------------------------------------------------------------------------
// ALPHABETA ALGORITHM
//--------------------------------------------------------------------------

#define INFINITY (1000)
#define MAX_DEPTH (10)

//--------------------------------------------------------------------------

enum {TP_HUMAN,TP_CPU1,TP_CPU2,TP_CPU3};
enum {WS_WIN0,WS_WIN1,WS_EXAEQUO,WS_NONE};

//--------------------------------------------------------------------------


typedef struct
{
	int x,y;
}
TPoint;

typedef struct
{
	int Holes[14];
	int turn;
	int win_state;
	int position;
}
TBoard;


typedef struct
{
	TBoard Boards[BOARDS_COUNT];
	int step;
	
	int hand;
	
	// options
	
	int AI_Computers[2];
	int counters;
	int skip_initial_hole;
	int null_captures;
	int skip_opp_kalahah;
	
	TPoint MousePos;
	
	// computer algo
	
	int algo_active;
	
	int algo_turn;
	int depth_max;
	
	int best_count;
	int best_list[14];
	int best_score;
	int best_play;
	
	
	
}
TGame;

//--------------------------------------------------------------------------


int Algo_Evaluate(void);
int Algo_AlphaBeta(int depth, int A, int B);
int Algo_GetBestPos(void);
void Algo_ShowAlgoInfo(void);

//--------------------------------------------------------------------------

void DrawHole (int Hole);
void RefreshScreen(void);
void DrawCursor(void);

void PlaceCursor(void);
void MoveHoleCounter(int HoleSrc, int HoleDest, int Count);
void PlayPos ( int Position);
void CheckForEndGame(void);
void NewGame(void);
void MouseMove(TPoint Point);
void UndoMove(void);
void BeginTurn(void);

//--------------------------------------------------------------------------

